import java.util.*;
import javax.swing.JOptionPane;
import javax.swing.*;

public class DataDescription
{

private String[][][] frekvence;
private double[][] vysledkyPopisStat;
private String[] hodnotyModus;
private int [] pocetHodnot;


     public DataDescription()
    {
    }

 
public String[][][] getFrekvence() {
return frekvence;
}
    
public double[][] getVysledkyPopisStat() {
return vysledkyPopisStat;
}

public int[] getPocetHodnotAtributu() {
return pocetHodnot;
}

public String[] getHodnotyModus() {
return hodnotyModus;
}

public void popis(String[][] data, int radky, int sloupce, int vaha1, String[][] typAtributu1 ) {
String [][] stav = data;
int kolikRadku = radky;
int kolikSloupcu = sloupce;
int vaha = vaha1;
String [][] typAtributu = typAtributu1;
vysledkyPopisStat = new double [6][kolikSloupcu + 1];
hodnotyModus = new String[kolikSloupcu +1];
pocetHodnot = new int [sloupce + 1];


/****************************************************************************************************************
 *v tuto chvili je urceno, ktery sloupec obsahuje vahu 
 *
 *  Pole frekvence: 

 *  patro [][][1] obsahuje: hodnoty 
 *  patro [][][2] obsahuje: cetnosti
 *  patro [][][3] obsahuje: rel. cetnosti

*/
frekvence = new String[kolikRadku+1][kolikSloupcu+1][4];
for (int x = 0; x <= kolikRadku; x++) {
for (int y = 0; y <= kolikSloupcu; y++) {
frekvence[x][y][0]= "";
frekvence[x][y][1]= "";
frekvence[x][y][2]= "";
frekvence[x][y][3]= "";

}
}
Map<String, Integer> m = new TreeMap<String, Integer>();
int x = 1;
int y = 1;
while (y <= kolikSloupcu) {
for (x = 2; x <= kolikRadku; x++) {
if (!stav[x][y].equals("")) { 
String a = stav[x][y];
Integer freq = m.get(a);
if (vaha == 0) {
m.put(a, (freq == null) ? 1 : freq + 1);
}
else {
m.put(a, (freq == null) ? Integer.parseInt(stav[x][vaha]) : freq + Integer.parseInt(stav[x][vaha]));
}
}

}

int soucetFrekvenci = 0;
int w = 1;
Set<Map.Entry<String,Integer>> mnozinaDvojic = m.entrySet(); 
for(Map.Entry <String, Integer> dvojice : mnozinaDvojic) { 
frekvence[w][y][1] = dvojice.getKey();
frekvence[w][y][2] = dvojice.getValue().toString();

if (!frekvence[0][y][2].equals("")) {
soucetFrekvenci = Integer.parseInt(frekvence[0][y][2]) + Integer.parseInt(frekvence[w][y][2]);
}
else
{
soucetFrekvenci = Integer.parseInt(frekvence[w][y][2]);
}

frekvence[0][y][2] = "" + soucetFrekvenci;

w++;
} // for Map.Entry
pocetHodnot[y] = m.size();
m.clear();
y++;
} // while

double relCetnost = 0;

for (y = 1; y <= kolikSloupcu; y++ ) {
for (x = 1; x <= kolikRadku; x++ ) {
if (!frekvence[x][y][2].equals("")) {
relCetnost = Double.parseDouble(frekvence[x][y][2])/Double.parseDouble(frekvence[0][y][2]);
frekvence[x][y][3] = "" + ((double)Math.round(relCetnost * 100) / 100);
}
}
}


double min = Double.MAX_VALUE;
double max = Double.MIN_VALUE;
double soucet = 0;
double prumer = 0;
double delitelPrumeru = 1;
double hodnota;

for (y = 1; y <= kolikSloupcu; y++) {
for (x = 2; x <= kolikRadku; x++) {

if (!stav[x][y].equals("") && typAtributu[2][y].equals("cislo")) {
if (x == 2) {
min = Double.parseDouble(stav[x][y]);
max = Double.parseDouble(stav[x][y]);
}

hodnota = Double.parseDouble(stav[x][y]);

if (min > hodnota) {
min = hodnota;
}
if (max < hodnota) {
max = hodnota;
}

if (vaha > 0) {
soucet = soucet + (hodnota * vaha);
delitelPrumeru = delitelPrumeru + vaha;
}
else {
soucet = soucet + hodnota;
delitelPrumeru++;
}
} // if !stav = ""
} // for x
prumer = soucet / (delitelPrumeru-1);
vysledkyPopisStat[1][y] = min;
vysledkyPopisStat[2][y] = max;
vysledkyPopisStat[3][y] = (double)Math.round(prumer * 100)/100;
min = 0;
max = 0;
soucet = 0;
prumer = 0;
delitelPrumeru = 1;

} // for y




double sumaSmoch = 0;
int delitelSmoch = 1;
for (y = 1; y <= kolikSloupcu; y++) {
for (x = 2; x <= kolikRadku; x++) {
if (!stav[x][y].equals("") && typAtributu[2][y].equals("cislo") && vaha == 0) {
hodnota = Double.parseDouble(stav[x][y]);
sumaSmoch = sumaSmoch + (hodnota - vysledkyPopisStat[3][y])*(hodnota - vysledkyPopisStat[3][y]);
delitelSmoch++;
}
if (!stav[x][y].equals("") && typAtributu[2][y].equals("cislo") && vaha > 0) {
hodnota = Double.parseDouble(stav[x][y]);
sumaSmoch = sumaSmoch + (((hodnota - vysledkyPopisStat[3][y])*(hodnota - vysledkyPopisStat[3][y]))*Double.parseDouble(stav[x][vaha]));
delitelSmoch = delitelSmoch + Integer.parseInt(stav[x][vaha]);
}

}

vysledkyPopisStat[4][y] = (double)Math.round(Math.sqrt(sumaSmoch/(delitelSmoch-1)) * 100)/100;
sumaSmoch = 0;
delitelSmoch = 1;
}

double hodnotaMod;
for (y = 1; y <= kolikSloupcu; y++) {
vysledkyPopisStat[5][y] = Double.MIN_VALUE;
  hodnotyModus[y] = "neni modus";
for (x = 2; x <= kolikRadku; x++) {
if (!frekvence[x][y][2].equals("") && (vaha == 0)) {
  hodnotaMod = Double.parseDouble(frekvence[x][y][2]);

    if (vysledkyPopisStat[5][y] < hodnotaMod) {
  vysledkyPopisStat[5][y] = hodnotaMod;
    
 }

}

if (!frekvence[x][y][2].equals("") && (vaha != 0)) {
hodnotaMod = Double.parseDouble(frekvence[x][y][2]);
 if (vysledkyPopisStat[5][y] < hodnotaMod) {
  vysledkyPopisStat[5][y] = hodnotaMod * Double.parseDouble(frekvence[x][vaha][2]) ;
  }
}

}
}


} // metoda popis   

} // class
