import java.util.*;
import javax.swing.*;

public class DataKapsa
{

String[][] stavData;
int pocetRadkuSouboru;
int pocetSloupcuSouboru; 
String[] jmenaAtributuVaha;
String[] jmenaAtributuCil;
String[] jmenaAtributu;
String[][] typAtributu;
String[][][] frekvence;
String[][] vybraneObj;
double [][] popisStatistika;
String[] hodnotyModus;
double[] attrRelevance; 
double[][] conti;
int [] pocetHodnotAtributu;
String[][] dataTrenovaci;
String[][] dataTestovaci;

int pocetSloupcuTypuNumeric;
int vyberObjRadku;
int vybranyCil;
int vybranaVaha;

public static DataKapsa instanceDataKapsa = new DataKapsa();
public static DataKapsa getInstance () {
return instanceDataKapsa;
}

private DataKapsa() {
}



public void isAttributeNumeric() {
typAtributu = new String [3][pocetSloupcuSouboru + 1];
for (int y = 1; y<=pocetSloupcuSouboru; y++) {
typAtributu[1][y] = stavData[1][y];
}

int x = 2;
boolean numeric = true;
for (int y = 1; y <= pocetSloupcuSouboru; y++) {
while (numeric && x <= pocetRadkuSouboru) {
try {
double hodnota = Double.parseDouble(stavData[x][y]);
}
catch (NumberFormatException e) {
if (!stavData[x][y].equals("")) {
typAtributu[2][y] = "text";
numeric = false;
}
} // catch
x++;
} // while
if (numeric) {
typAtributu[2][y] = "cislo";
}
numeric = true;
x = 2;
} // for

} // isAttributeNumeric


public void zjistiAtributy() {
jmenaAtributuCil = new String[pocetSloupcuSouboru + 1];
int pocitadloNumeric = 1;
for (int i = 1; i<= pocetSloupcuSouboru; i++) {
jmenaAtributuCil[i] = typAtributu[1][i];
if (typAtributu[2][i].equals("cislo")) {
pocitadloNumeric++;
}
}
jmenaAtributuCil[0] = "choose";
pocetSloupcuTypuNumeric = pocitadloNumeric;
jmenaAtributuVaha = new String[pocitadloNumeric];
jmenaAtributuVaha[0] = "No float";
int ii = 1;
for (int i = 1; i<= pocetSloupcuSouboru; i++) {
if (typAtributu[2][i].equals("cislo")) {
jmenaAtributuVaha[ii] = typAtributu[1][i];
ii++;
}
}
jmenaAtributu = new String[pocetSloupcuSouboru];
for (int i = 1; i<= pocetSloupcuSouboru; i++) {
jmenaAtributu[i-1] = jmenaAtributuCil[i];
}
}

public void zaraditUsek(int prvniObj, int posledniObj) {
vyberObjRadku = posledniObj - prvniObj +2;
int xx = prvniObj;
vybraneObj = new String [vyberObjRadku+1][pocetSloupcuSouboru + 1];
for (int x = -1; x<vyberObjRadku; x++) {
for (int y = 0; y<=pocetSloupcuSouboru; y++) {
if (x == -1) {
vybraneObj[0][y] = stavData[0][y];
}
else if (x == 0) {
vybraneObj[1][y] = stavData[1][y];
}
else {
vybraneObj[x+1][y] = stavData[xx+1][y];
}

}
if (x > 0) {
 xx++;
}
}

}

public void vyraditUsek(int prvniObj, int posledniObj) {
vyberObjRadku = pocetRadkuSouboru - (posledniObj - prvniObj + 1);
vybraneObj = new String [vyberObjRadku + 1][pocetSloupcuSouboru + 1];
int xx = 0;
for (int x = 0; x<=pocetRadkuSouboru; x++) {
if ((x < prvniObj+1) || (x > posledniObj+1)) {
for (int y = 0; y<=pocetSloupcuSouboru; y++) {
vybraneObj[xx][y] = stavData[x][y];

}
xx++;
}
}
}

public void sample(boolean tridaB, String trida, boolean abs, int kolik, boolean pomer) {
vybraneObj = null;
vybraneObj = new String[kolik + 2][pocetSloupcuSouboru + 1];
int cilRadku = pocetHodnotAtributu[vybranyCil];
String[][] poctyTrid = new String[cilRadku + 1][5];
for (int x = 1; x<=cilRadku; x++) {
poctyTrid[x][1] = frekvence[x][vybranyCil][1];
poctyTrid[x][2] = frekvence[x][vybranyCil][2];
}
// ulozeni poctu hodnot vybrane tridy
for (int x = 1; x<=cilRadku; x++) {
if (frekvence[x][vybranyCil][1].equals(trida)) {
poctyTrid[x][3] = poctyTrid[x][2];
}
}



if (abs && !pomer && !tridaB) {

int x = 2;
int w = 2;
while (x<=kolik+1) {
double nahoda =Math.random();
if (nahoda >= 0.5) {

for (int y = 0; y<=pocetSloupcuSouboru; y++) {
vybraneObj[x][y] = stavData[w][y];
}
x++;
w++;
if (w > pocetRadkuSouboru) {
w = 1;
}
}
}

for (int y = 0; y<=pocetSloupcuSouboru; y++) {
vybraneObj[1][y] = stavData[1][y];
}

}


if (abs && !pomer && tridaB) {

int w = 0;
int x = 0;
try {
for (x = 0; x<=pocetRadkuSouboru; x++) {
for (int y = 0; y<=pocetSloupcuSouboru; y++) {
if (stavData[x][y].equals(trida) || x < 2) {
vybraneObj[w][y] = stavData[x][y];
w++;
}
}
}
}
catch (ArrayIndexOutOfBoundsException e) {
JOptionPane.showMessageDialog(null, "Upravte vstup, vybrana trida prevysuje pocet vybiranych radku!", "Spatny vstup", JOptionPane.INFORMATION_MESSAGE);
}

x = w;
w = 2;
while (x<=kolik) {
double nahoda =Math.random();
if (nahoda >= 0.5 && !stavData[w][vybranyCil].equals(trida)) {

for (int y = 0; y<=pocetSloupcuSouboru; y++) {
vybraneObj[x][y] = stavData[w][y];
}
x++;
}
w++;
if (w > pocetRadkuSouboru) {
w = 1;
}
}
}


if (abs && pomer && !tridaB) {

for (int x = 1; x<=cilRadku; x++) {
poctyTrid[x][3] = "" + Math.round(Double.parseDouble(poctyTrid[x][2]) * kolik / pocetRadkuSouboru);
poctyTrid[x][4] = "" + 0;
}

int x = 2;
int puvodni = 2;
int nova = 0;
while (x<=kolik+1) {
puvodni = x;
if (nova == puvodni) {break;}
for (int z = 1; z<=cilRadku; z++) {
for (int w = 2; w<=pocetRadkuSouboru; w++) {
double nahoda = Math.random();
if (nahoda <= Double.parseDouble(poctyTrid[z][2])/pocetRadkuSouboru && (Integer.parseInt(poctyTrid[z][2]) > Integer.parseInt(poctyTrid[z][4]) ) 
&& stavData[w][vybranyCil].equals(poctyTrid[z][1]) && x<=kolik+1) {
for (int y = 0; y<=pocetSloupcuSouboru; y++) {
vybraneObj[x][y] = stavData[w][y];
System.out.println("obj... " + vybraneObj[x][y]);
}
x++;
}
}
}

for (int y = 0; y<=pocetSloupcuSouboru; y++) {
vybraneObj[1][y] = stavData[1][y];
}
nova = x;
}
}




if (abs && pomer && tridaB) {
// ???
}

stavData = null;
stavData = vybraneObj;
pocetRadkuSouboru = kolik;
for (int x = 0; x < 10; x++) {
for (int y = 0; y < 4; y++) {
System.out.println("stav x y data" + x + " " + y +  vybraneObj[x][y]);
}
}

} // sample

public void smazatData() {

} // smazatData

} // class

