import java.util.*;
import java.io.*;

/**
 * Tda potajc zvislost dvou atribut dle Mutual Information.
 */

public class ASMI
{
    public ASMI()
    {
    }
DataKapsa datoveStruktury;

public void MI() {
datoveStruktury = datoveStruktury.getInstance();
Grafika.oknoVysledku.setText(Grafika.oknoVysledku.getText() + " \n " + "Attribute selection based on Mutual Information: ");
double[][] MIvysledky = new double[datoveStruktury.pocetSloupcuSouboru * datoveStruktury.pocetSloupcuSouboru * datoveStruktury.pocetSloupcuSouboru][5];
int radekMIvysledku = 1;

for (int i = 1; i <= datoveStruktury.pocetSloupcuSouboru; i++) {
for (int j = 1; j <= datoveStruktury.pocetSloupcuSouboru; j++) {
if (i<j && i!= datoveStruktury.vybranaVaha && j!= datoveStruktury.vybranaVaha && i!= datoveStruktury.vybranyCil && j!= datoveStruktury.vybranyCil) {
int sloupec1 = i;
int sloupec2 = j;
int sloupec3 = datoveStruktury.vybranyCil;
int pocetHodnotSloupec1 = datoveStruktury.pocetHodnotAtributu[sloupec1]; 
int pocetHodnotSloupec2 = datoveStruktury.pocetHodnotAtributu[sloupec2]; 
int pocetHodnotSloupec3 = datoveStruktury.pocetHodnotAtributu[sloupec3]; 
String poleTrojKombinaci[][] = new String [(pocetHodnotSloupec1 * pocetHodnotSloupec2 * pocetHodnotSloupec3 ) + 1][12];

/*
 * zaznamenej vsechny mozne kombinace hodnot ve 2 sloupcich a v cilovem sloupci
 */

int cisloRadku3 = 0;
for (int a = 1; a<= pocetHodnotSloupec1; a++) {
for (int b = 1; b<= pocetHodnotSloupec2; b++) {
for (int c = 1; c<= pocetHodnotSloupec3; c++) {
cisloRadku3++;
poleTrojKombinaci[cisloRadku3][1] = "" + datoveStruktury.frekvence[a][sloupec1][1];
poleTrojKombinaci[cisloRadku3][2] = "" + datoveStruktury.frekvence[b][sloupec2][1];
poleTrojKombinaci[cisloRadku3][3] = "" + datoveStruktury.frekvence[c][sloupec3][1];
poleTrojKombinaci[cisloRadku3][4] = "" + poleTrojKombinaci[cisloRadku3][1] + ";" + poleTrojKombinaci[cisloRadku3][2];
poleTrojKombinaci[cisloRadku3][5] = "" + poleTrojKombinaci[cisloRadku3][1] + ";" + poleTrojKombinaci[cisloRadku3][2]+ ";" + poleTrojKombinaci[cisloRadku3][3];
poleTrojKombinaci[cisloRadku3][6] = "" + datoveStruktury.frekvence[a][sloupec1][2];
poleTrojKombinaci[cisloRadku3][7] = "" + datoveStruktury.frekvence[b][sloupec2][2];
poleTrojKombinaci[cisloRadku3][8] = "" + datoveStruktury.frekvence[c][sloupec3][2];
poleTrojKombinaci[cisloRadku3][9] = "0";
poleTrojKombinaci[cisloRadku3][10] = "0";
} // for c
} // for b
} // for a

/*
 * projdi soubor a zaznamenej pocty kombinaci
 */

int pocetRadkuKombinaci = cisloRadku3;

for (int e = 1; e<= pocetRadkuKombinaci; e++) {
for (int d = 1; d<= datoveStruktury.pocetRadkuSouboru; d++) {

if ((datoveStruktury.stavData[d][sloupec1]).equals(poleTrojKombinaci[e][1]) && (datoveStruktury.stavData[d][sloupec2]).equals(poleTrojKombinaci[e][2]) && (datoveStruktury.stavData[d][sloupec3]).equals(poleTrojKombinaci[e][3])) {
if (datoveStruktury.vybranaVaha == 0) {
poleTrojKombinaci[e][9] = (Double.parseDouble(poleTrojKombinaci[e][9]) + 1) + ""; 
poleTrojKombinaci[e][10] = (Double.parseDouble(poleTrojKombinaci[e][10]) + 1) + ""; 
}
else {
poleTrojKombinaci[e][9] = (Double.parseDouble(poleTrojKombinaci[e][9]) + Double.parseDouble(datoveStruktury.stavData[d][datoveStruktury.vybranaVaha])) + ""; 
poleTrojKombinaci[e][10] = (Double.parseDouble(poleTrojKombinaci[e][10]) + Double.parseDouble(datoveStruktury.stavData[d][datoveStruktury.vybranaVaha])) + ""; 
}
}

} // for d

} // for e

/*
 * zjisti, ktere z moznych kombinaci jsou pouzite ...
 */

HashMap<String, Double> mapa2 = new HashMap<String, Double>();
HashMap<String, Double> mapa3 = new HashMap<String, Double>();
for (int f = 1; f<= pocetRadkuKombinaci; f++) {
String komb2 = poleTrojKombinaci[f][4];
double freq2 = Double.parseDouble(poleTrojKombinaci[f][9]);
if (!poleTrojKombinaci[f][9].equals("0")) {
Double freq2a = mapa2.get(komb2);
mapa2.put(komb2, (freq2a == null) ? freq2 : freq2a + freq2);


}

String komb3 = poleTrojKombinaci[f][5];
double freq3 = Double.parseDouble(poleTrojKombinaci[f][10]);
if (!poleTrojKombinaci[f][10].equals("0")) {
Double freq3a = mapa3.get(komb3);
mapa3.put(komb3, (freq3a == null) ? freq3 : freq3a + freq3);


}


} // for f

String pouziteDvojKombinace[][] = new String [mapa2.size() + 1][12];
int cisloRadku2 = 1;
Set<Map.Entry<String,Double>> mnozinaDvojic2 = mapa2.entrySet(); 
for(Map.Entry <String, Double> dvojice2 : mnozinaDvojic2) {
pouziteDvojKombinace[cisloRadku2][4] = dvojice2.getKey();
pouziteDvojKombinace[cisloRadku2][9] = "" + dvojice2.getValue();
cisloRadku2++;
}

String pouziteTrojKombinace[][] = new String [mapa3.size() + 1][15];
cisloRadku3 = 1;
Set<Map.Entry<String,Double>> mnozinaDvojic3 = mapa3.entrySet(); 
for(Map.Entry <String, Double> dvojice3 : mnozinaDvojic3) {
pouziteTrojKombinace[cisloRadku3][5] = dvojice3.getKey();
pouziteTrojKombinace[cisloRadku3][10] = "" + (dvojice3.getValue() / datoveStruktury.pocetRadkuSouboru);
cisloRadku3++;
}


int pouzitychKombinaci2 = cisloRadku2;
int pouzitychKombinaci3 = cisloRadku3;

for (int g = 1; g< pouzitychKombinaci2; g++) {
for (int f = 1; f<= pocetRadkuKombinaci; f++) {
if (pouziteDvojKombinace[g][4].equals(poleTrojKombinaci[f][4])) {
pouziteDvojKombinace[g][1] = poleTrojKombinaci[f][1];
pouziteDvojKombinace[g][2] = poleTrojKombinaci[f][2];
pouziteDvojKombinace[g][6] = poleTrojKombinaci[f][6];
pouziteDvojKombinace[g][7] = poleTrojKombinaci[f][7];

break;
}
}
}

for (int g = 1; g< pouzitychKombinaci3; g++) {
for (int f = 1; f<= pocetRadkuKombinaci; f++) {
if (pouziteTrojKombinace[g][5].equals(poleTrojKombinaci[f][5])) {
pouziteTrojKombinace[g][1] = poleTrojKombinaci[f][1];
pouziteTrojKombinace[g][2] = poleTrojKombinaci[f][2];
pouziteTrojKombinace[g][3] = poleTrojKombinaci[f][3];
pouziteTrojKombinace[g][6] = poleTrojKombinaci[f][6];
pouziteTrojKombinace[g][7] = poleTrojKombinaci[f][7];
pouziteTrojKombinace[g][8] = poleTrojKombinaci[f][8];
break;
}
}
}

double logY = 0;
double pY = 0;
for (int h = 1; h<datoveStruktury.pocetHodnotAtributu[sloupec3]; h++) {
pY = Double.parseDouble(datoveStruktury.frekvence[h][sloupec3][3]);
logY = logY + (pY * Math.log(pY));
}

for (int o = 1; o < pouzitychKombinaci3 ; o++) {
for (int p = 1; p < pouzitychKombinaci2 ; p++) {
if (pouziteTrojKombinace[o][1].equals(pouziteDvojKombinace[p][1]) && pouziteTrojKombinace[o][2].equals(pouziteDvojKombinace[p][2]) ) {
pouziteTrojKombinace[o][13] = "" + (Double.parseDouble(pouziteDvojKombinace[p][9]) / datoveStruktury.pocetRadkuSouboru) ;
}
}
for (int h = 1; h<datoveStruktury.pocetHodnotAtributu[sloupec3]; h++) {
pouziteTrojKombinace[o][14] = datoveStruktury.frekvence[h][sloupec3][3];
}
}

 
double vysledek = 0;
for (int k = 1; k< pouzitychKombinaci3; k++) {
double kombCil = Double.parseDouble(pouziteTrojKombinace[k][14]);
double komb2 = Double.parseDouble(pouziteTrojKombinace[k][13]);
double komb3 = Double.parseDouble(pouziteTrojKombinace[k][10]);

vysledek = vysledek + (komb3 + Math.log(komb3/ (komb2*kombCil) ));
}

vysledek = vysledek / ((-1) * logY) ;
vysledek = Math.round( vysledek * 100) / 100;

MIvysledky[radekMIvysledku][1] = i;
MIvysledky[radekMIvysledku][2] = j;
MIvysledky[radekMIvysledku][3] = vysledek;
Grafika.oknoVysledku.setText(Grafika.oknoVysledku.getText() + " \n " + "Attribute " + MIvysledky[radekMIvysledku][1] + " and attribute " + MIvysledky[radekMIvysledku][2] + " : " + MIvysledky[radekMIvysledku][3]);    

radekMIvysledku++;
} // if (i<j && i!= Vaha && j!= Vaha
} // for j
} // for i


}// dependence
}// class
